package io.fabric8.openshift.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class BuildConfigBuilder extends BuildConfigFluentImpl<BuildConfigBuilder> implements VisitableBuilder<BuildConfig,BuildConfigBuilder>{

    BuildConfigFluent<?> fluent;
    Boolean validationEnabled;

    public BuildConfigBuilder(){
            this(true);
    }
    public BuildConfigBuilder(Boolean validationEnabled){
            this(new BuildConfig(), validationEnabled);
    }
    public BuildConfigBuilder(BuildConfigFluent<?> fluent){
            this(fluent, true);
    }
    public BuildConfigBuilder(BuildConfigFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new BuildConfig(), validationEnabled);
    }
    public BuildConfigBuilder(BuildConfigFluent<?> fluent,BuildConfig instance){
            this(fluent, instance, true);
    }
    public BuildConfigBuilder(BuildConfigFluent<?> fluent,BuildConfig instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withApiVersion(instance.getApiVersion()); 
            fluent.withKind(instance.getKind()); 
            fluent.withMetadata(instance.getMetadata()); 
            fluent.withSpec(instance.getSpec()); 
            fluent.withStatus(instance.getStatus()); 
            this.validationEnabled = validationEnabled; 
    }
    public BuildConfigBuilder(BuildConfig instance){
            this(instance,true);
    }
    public BuildConfigBuilder(BuildConfig instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withApiVersion(instance.getApiVersion()); 
            this.withKind(instance.getKind()); 
            this.withMetadata(instance.getMetadata()); 
            this.withSpec(instance.getSpec()); 
            this.withStatus(instance.getStatus()); 
            this.validationEnabled = validationEnabled; 
    }

    public BuildConfig build(){
            BuildConfig buildable = new BuildConfig(fluent.getApiVersion(),fluent.getKind(),fluent.getMetadata(),fluent.getSpec(),fluent.getStatus());
            io.fabric8.kubernetes.api.builder.ValidationUtils.validate(buildable);
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            BuildConfigBuilder that = (BuildConfigBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
