package io.fabric8.openshift.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class PolicyListBuilder extends PolicyListFluentImpl<PolicyListBuilder> implements VisitableBuilder<PolicyList,PolicyListBuilder>{

    PolicyListFluent<?> fluent;
    Boolean validationEnabled;

    public PolicyListBuilder(){
            this(true);
    }
    public PolicyListBuilder(Boolean validationEnabled){
            this(new PolicyList(), validationEnabled);
    }
    public PolicyListBuilder(PolicyListFluent<?> fluent){
            this(fluent, true);
    }
    public PolicyListBuilder(PolicyListFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new PolicyList(), validationEnabled);
    }
    public PolicyListBuilder(PolicyListFluent<?> fluent,PolicyList instance){
            this(fluent, instance, true);
    }
    public PolicyListBuilder(PolicyListFluent<?> fluent,PolicyList instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withApiVersion(instance.getApiVersion()); 
            fluent.withItems(instance.getItems()); 
            fluent.withKind(instance.getKind()); 
            fluent.withMetadata(instance.getMetadata()); 
            this.validationEnabled = validationEnabled; 
    }
    public PolicyListBuilder(PolicyList instance){
            this(instance,true);
    }
    public PolicyListBuilder(PolicyList instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withApiVersion(instance.getApiVersion()); 
            this.withItems(instance.getItems()); 
            this.withKind(instance.getKind()); 
            this.withMetadata(instance.getMetadata()); 
            this.validationEnabled = validationEnabled; 
    }

    public PolicyList build(){
            PolicyList buildable = new PolicyList(fluent.getApiVersion(),fluent.getItems(),fluent.getKind(),fluent.getMetadata());
            io.fabric8.kubernetes.api.builder.ValidationUtils.validate(buildable);
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            PolicyListBuilder that = (PolicyListBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
