
package io.fabric8.kubernetes.api.model.authentication;

import java.util.HashMap;
import java.util.Map;
import javax.annotation.Generated;
import javax.validation.Valid;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import io.fabric8.kubernetes.api.model.Doneable;
import io.fabric8.kubernetes.api.model.KubernetesResource;
import io.sundr.builder.annotations.Buildable;
import io.sundr.builder.annotations.Inline;
import lombok.EqualsAndHashCode;
import lombok.ToString;


/**
 * 
 * 
 */
@JsonInclude(JsonInclude.Include.NON_NULL)
@Generated("org.jsonschema2pojo")
@JsonPropertyOrder({
    "apiVersion",
    "kind",
    "metadata",
    "authenticated",
    "error",
    "user"
})
@JsonDeserialize(using = com.fasterxml.jackson.databind.JsonDeserializer.None.class)
@ToString
@EqualsAndHashCode
@Buildable(editableEnabled = false, validationEnabled = true, generateBuilderPackage = true, builderPackage = "io.fabric8.kubernetes.api.builder", inline = @Inline(type = Doneable.class, prefix = "Doneable", value = "done"))
public class TokenReviewStatus implements KubernetesResource
{

    /**
     * 
     * 
     */
    @JsonProperty("authenticated")
    private Boolean authenticated;
    /**
     * 
     * 
     */
    @JsonProperty("error")
    private String error;
    /**
     * 
     * 
     */
    @JsonProperty("user")
    @Valid
    private UserInfo user;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();

    /**
     * No args constructor for use in serialization
     * 
     */
    public TokenReviewStatus() {
    }

    /**
     * 
     * @param authenticated
     * @param error
     * @param user
     */
    public TokenReviewStatus(Boolean authenticated, String error, UserInfo user) {
        this.authenticated = authenticated;
        this.error = error;
        this.user = user;
    }

    /**
     * 
     * 
     * @return
     *     The authenticated
     */
    @JsonProperty("authenticated")
    public Boolean getAuthenticated() {
        return authenticated;
    }

    /**
     * 
     * 
     * @param authenticated
     *     The authenticated
     */
    @JsonProperty("authenticated")
    public void setAuthenticated(Boolean authenticated) {
        this.authenticated = authenticated;
    }

    /**
     * 
     * 
     * @return
     *     The error
     */
    @JsonProperty("error")
    public String getError() {
        return error;
    }

    /**
     * 
     * 
     * @param error
     *     The error
     */
    @JsonProperty("error")
    public void setError(String error) {
        this.error = error;
    }

    /**
     * 
     * 
     * @return
     *     The user
     */
    @JsonProperty("user")
    public UserInfo getUser() {
        return user;
    }

    /**
     * 
     * 
     * @param user
     *     The user
     */
    @JsonProperty("user")
    public void setUser(UserInfo user) {
        this.user = user;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

}
